import numpy as np
import time
import cv2
import math

width = 300  #Window のサイズ（横）
height = 200  #Window のサイズ（縦）

max_length = 100  #棒の半分の長さ（左右にmax_length 伸ばすため）

dt = 0.02  #時間刻み
gravity = 9.80665  #重力加速度
s = 0.0  #レールの角度
r = 10.0  #ボールの半径
v = 0.0  #ボールの速度
x = np.random.randint(-max_length,max_length)

while True:  #無限のループ
    costheta = math.cos(s)
    sintheta = math.sin(s)
    v = v + 50*(gravity * sintheta) * dt
    if x<-max_length and v<0:
        v = 0.0
    if x>max_length and v>0:
        v = 0.0
    x = x + v * dt

    img = cv2.imread("300x200.bmp", flags=cv2.IMREAD_GRAYSCALE)
    y = height/ 2 + x*math.tan(s)-r/costheta
    x1 = width / 2 + max_length * costheta
    y1 = height / 2 + max_length * sintheta
    x2 = width / 2 - max_length * costheta
    y2 = height / 2 - max_length * sintheta
    cv2.rectangle(img, (int(width / 2-20), int(0)), (int(width / 2+20), int(height)), 198, -1)
    cv2.circle(img, (int(x+width/2), int(y)), int(r), 127, -1)
    cv2.line(img, (int(x1), int(y1)), (int(x2), int(y2)), 32, 4)
    cv2.imshow("Simulation",img)

    k = cv2.waitKey(10)
    if k==113:#q:
        cv2.destroyAllWindows()
        t = -1
        break

    s = -x*0.001-v*0.0004
